
/*
 * QDPF - Quick And Dirty Port Forwarder
 *
 * (C) John Hawksley 2000
 *
 * LICENSING:  See readme.txt, or http://www.hawksley.net/software/qdpf/
 *
 * mail: john at bawue.de
 *
 * REVISION: 1.01
 */

/**
 * This is the main server class thread.
 *
 * All that's going on here is a main() executive which instantiates a new
 * object of this type.  pf() constructor is called, which creates a new
 * server socket, and starts the thread.
 *
 * The run() method blocks on the accept() (so no sleep() necessary) and
 * creates a new Connection object for each of the incoming.
 *
 */

import java.io.*;
import java.net.*;

public class pf
	extends Thread
{
	protected static int inport;
	protected static int outport;
	protected ServerSocket inSocket;
	protected Socket outSocket;
	protected static String remoteHost;

	public pf()
	{

		try
		{
			inSocket = new ServerSocket(inport);
		}
		catch( IOException e )
		{
			fail(e, "Couldn't create server socket on port " + inport);
		}
		this.start();
	}

	public static void fail(Exception e, String msg)
	{
		System.err.println(msg + ": " + e);
		System.exit(1);
	}

	public void run()
	{
		try
		{
			while(true)
			{
				Socket clientSocket = inSocket.accept();
				Connection c = new Connection(clientSocket, outport, remoteHost);
			}
		}
		catch(IOException e)
		{
			fail(e, "Problem listening for new cx");
		}
	}

	public static void main(String[] args)
	{

		if (args.length != 3)
			doSyntaxAndExit();

		// implicit return

		try
		{
			inport = Integer.parseInt(args[0]);
			outport = Integer.parseInt(args[1]);
			remoteHost = args[2];
		}
		catch (NumberFormatException e)
		{
			fail(e, "Couldn't parse out port numbers");
		}
		new pf();
	}

	public static void doSyntaxAndExit()
	{

		System.out.println( "QDPF Version 1.01 john@bawue.de\n\n"  + "SYNTAX:\n" +
						   "\t[java] pf local_port remote_port remote_host\n");

		System.exit(-1);

	}

}
